#include <stdio.h>
#define CURGOV "/sys/devices/system/cpu/cpufreq/policy0/scaling_governor"
#define FREQS "/sys/devices/system/cpu/cpufreq/policy0/scaling_available_frequencies"
#define MAXSPDPATH "/sys/devices/system/cpu/cpufreq/policy0/scaling_max_freq"
#define SETSPDPATH "/sys/devices/system/cpu/cpufreq/policy0/scaling_setspeed"
#define CURTEMPPATH "/sys/devices/virtual/thermal/thermal_zone0/temp"

int comparestrings(char *a, char *b){
  int c = 0;
  while(a[c]!='\0' && b[c]!='\0'){
    if(a[c] != b[c]){
      return 1;
    }
    c++;
  }
  return 0;
}

int getfilec(FILE *file, char arr[]){
  int c, i;
  i=0;
  while((c=fgetc(file)) != EOF){
    arr[i]=c;
    i++;
  }
  arr[i]='\0';
  return i;
}

int main(){
  char gov[20];
  FILE *govfile = fopen(CURGOV, "r");
  getfilec(govfile, gov);
  if (comparestrings(gov, "userspace\n") != 0){
    printf("error: userspace governor not set\n");
    return 1;
  }
  FILE *freqsfile = fopen(FREQS, "r");
  FILE *curmaxfile = fopen(MAXSPDPATH, "r");
  FILE *setspeedfile = fopen(SETSPDPATH, "r");
  FILE *curtempfile = fopen(CURTEMPPATH, "r");
  fclose(govfile);
  fclose(freqsfile);
  fclose(curmaxfile);
  fclose(setspeedfile);
  fclose(curtempfile);
  return 0;
}
